<template>
  <transition name="modal">
    <div
      class="ui-modal overlay component"
      v-if="show"
      @click="onClickOverlay"
      ref="overlay"
    >
      <div class="modal-content">
        <div class="header">
          <span class="close" @click="close" v-if="showCloseButton">close</span>
        </div>
        <slot></slot>
      </div>
    </div>
  </transition>
</template>
<script>
import { ref } from "vue";
export default {
  name: "BaseModal",
  emits: ["close"],
  props: {
    show: {
      default: null,
    },
    showCloseButton: {
      type: Boolean,
      default: false,
    },
    closeOnOverlay: {
      type: Boolean,
      default: false,
    },
  },
  setup(props, context) {
    const overlay = ref(null);

    function close() {
      context.emit("close");
    }
    function onClickOverlay($event) {
      if (props.closeOnOverlay && $event && $event.target === overlay.value) {
        close();
      }
    }
    return { overlay, close, onClickOverlay };
  },
};
</script>

<style lang="scss" scoped>
.ui-modal.overlay.component {
  width: 100vw;
  height: 100vh;
  z-index: 100;
  position: fixed;
  top: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.5);
  display: flex;
  justify-content: center;
  align-items: center;
  .modal-content {
    width: 100%;
    // max-width: 30rem;
    // margin-inline: 1.5rem;
    background-color: var(--clr-dark-navy);
    // border-radius: 8px;
    text-align: center;
    padding: 16px 0;
    .header {
      display: flex;
      justify-content: flex-end;
      .close {
        border: 1px solid black;
        padding: 2px;
        cursor: pointer;
      }
    }
  }
}

/* modal transition */
.modal-enter-active,
.modal-leave-active {
  transition: all 0.3s ease;
}
.modal-enter,
.modal-leave-to {
  padding-top: 100px;
  opacity: 0;
}
</style>
